/******************************************************************************
 *
 *
 *
 * Copyright (C) 1997-2015 by Dimitri van Heesch.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation under the terms of the GNU General Public License is hereby
 * granted. No representations are made about the suitability of this software
 * for any purpose. It is provided "as is" without express or implied warranty.
 * See the GNU General Public License for more details.
 *
 * Documents produced by analyze are derivative works derived from the
 * input used in their production; they are not affected by this license.
 */

/*
 *
 * Nickolay Semyonov
 * Andrey V. Stolyarov released Feb 14, 2001
 * Alexandr V. Chelpanov <cav@cryptopro.ru> released Sep 25, 2004
 * Благодарности: Vitaly A. Repin <vitaly@radio.hop.stu.neva.ru>,
 *    Михаил Глушенков <bbman@mail.ru>
 */

#ifndef TRANSLATOR_RU_H
#define TRANSLATOR_RU_H

class TranslatorRussian : public Translator
{
  public:
    /*! Used for identification of the language. */
    OGString idLanguage() override
    { return "russian"; }

    /* Used to get the command(s) for the language support. */
    OGString latexLanguageSupportCommand() override
    { return "\\usepackage[T2A]{fontenc}\n\\usepackage[russian]{babel}\n"; }

    OGString trISOLang() override
    { return "ru"; }
    OGString getLanguageString() override
    {
      return "0x419 Russian";
    }

    // --- Language translation methods -------------------

    /*! used in the compound documentation before a list of related functions. */
    OGString trRelatedFunctions() override
    { return "Относящиеся к классу функции"; }

    /*! subscript for the related functions. */
    OGString trRelatedSubscript() override
    { return "(не члены класса)"; }

    /*! header that is put before the detailed description of files, classes and namespaces. */
    OGString trDetailedDescription() override
    { return "Подробное описание"; }

    /*! header that is used when the summary tag is missing inside the details tag */
    OGString trDetails() override
    { return "Подробности"; }

    /*! header that is put before the list of typedefs. */
    OGString trMemberTypedefDocumentation() override
    { return "Определения типов"; }

    /*! header that is put before the list of enumerations. */
    OGString trMemberEnumerationDocumentation() override
    { return "Перечисления"; }

    /*! header that is put before the list of member functions. */
    OGString trMemberFunctionDocumentation() override
    { return "Методы"; }

    /*! header that is put before the list of member attributes. */
    OGString trMemberDataDocumentation() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Поля";
      }
      else
      {
        return "Данные класса";
      }
    }

    /*! this is the text of a link put after brief descriptions. */
    OGString trMore() override
    { return "Подробнее..."; }

    /*! put in the class documentation */
    /* Isn't used when optimization for C is on. */
    OGString trListOfAllMembers() override
    {
      return "Полный список членов класса";
    }

    /*! used as the title of the "list of all members" page of a class */
    /* Isn't used when optimization for C is on. */
    OGString trMemberList() override
    {
      return "Cписок членов класса";
    }

    /*! this is the first part of a sentence that is followed by a class name */
    /* Isn't used when optimization for C is on. */
    OGString trThisIsTheListOfAllMembers() override
    { return "Полный список членов класса"; }

    /*! this is the remainder of the sentence after the class name */
    /* Isn't used when optimization for C is on. */
    OGString trIncludingInheritedMembers() override
    { return ", включая наследуемые из базового класса"; }

    /*! this is put at the author sections at the bottom of man pages.
     *  parameter s is name of the project name.
     */
    OGString trGeneratedAutomatically(const OGString &s) override
    { OGString result="Автоматически создано analyze";
      if (!s.isEmpty()) result+=OGString(" для ")+s;
      result+=" из исходного текста.";
      return result;
    }

    /*! put after an enum name in the list of all members */
    OGString trEnumName() override
    { return "перечисление"; }

    /*! put after an enum value in the list of all members */
    OGString trEnumValue() override
    { return "элементы перечисления"; }

    /*! put after an undocumented member in the list of all members */
    OGString trDefinedIn() override
    { return "определено в"; }

    // quick reference sections

    /*! This is put above each page as a link to the list of all groups of
     *  compounds or files (see the \\group command).
     */
    OGString trModules() override
    { return "Группы"; }

    /*! This is put above each page as a link to the class hierarchy */
    OGString trClassHierarchy() override
    { return "Иерархия классов"; }

    /*! This is put above each page as a link to the list of annotated classes */
    OGString trCompoundList() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Структуры данных";
      }
      else
      {
        return "Классы";
      }
    }

    /*! This is put above each page as a link to the list of documented files */
    OGString trFileList() override
    { return "Файлы"; }

    /*! This is put above each page as a link to all members of compounds. */
    OGString trCompoundMembers() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Поля структур";
      }
      else
      {
        return "Члены классов";
      }
    }

    /*! This is put above each page as a link to all members of files. */
    /*??*/
    OGString trFileMembers() override
    {
      return "Список членов всех файлов";
    }

    /*! This is put above each page as a link to all related pages. */
    OGString trRelatedPages() override
    /* ?? Вариант перевода "См. также: " более удачный, но не в заголовке,
     как в данном случае. */
    { return "Описания"; }

    /*! This is put above each page as a link to all examples. */
    OGString trExamples() override
    { return "Примеры"; }

    /*! This is put above each page as a link to the search engine. */
    OGString trSearch() override
    { return "Поиск"; }

    /*! This is an introduction to the class hierarchy. */
    OGString trClassHierarchyDescription() override
    { return "Иерархия классов."; }

    /*! This is an introduction to the list with all files. */
    OGString trFileListDescription(bool extractAll) override
    {
      OGString result="Полный список ";
      if (!extractAll) result+="документированных ";
      result+="файлов.";
      return result;
    }

    /*! This is an introduction to the annotated compound list. */
    OGString trCompoundListDescription() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Структуры данных с их кратким описанием.";
      }
      else if (Config_getBool(OPTIMIZE_OUTPUT_SLICE))
      {
        return "Классы с их кратким описанием.";
      }
      else
      {
        return "Классы с их кратким описанием.";
      }
    }

    /*! This is an introduction to the page with all class members. */
    OGString trCompoundMembersDescription(bool extractAll) override
    {
        OGString result="Список всех ";
        if(!extractAll) result+="документированных ";
        if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
          result+="членов структур данных со ссылками на ";
        else
          result+="членов классов со ссылками на ";
        if(!extractAll)
        {
          if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
            result+="документацию по структуре для каждого члена.";
          else
            result+="документацию по классу для каждого члена.";
        }
        else
        {
          if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
            result += "структуры";
          else
            result += "классы";
          result+=", к которым они принадлежат.";
        }
        return result;
    }

    /*! This is an introduction to the page with all file members. */
    OGString trFileMembersDescription(bool extractAll) override
    {
      OGString result="Список всех ";
      if (!extractAll) result+="документированных ";

      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        result+="функций, переменных, макроопределений, "
                "перечислений и определений типов";
      }
      else
      {
        result+="членов файлов ";
      }
      result+=" со ссылками на ";
      if (extractAll)
        result+="файлы, к которым они принадлежат.";
      else
        result+="документацию.";
      return result;
    }

    /*! This is an introduction to the page with the list of all examples */
    OGString trExamplesDescription() override
    { return "Полный список примеров."; }

    /*! This is an introduction to the page with the list of related pages */
    OGString trRelatedPagesDescription() override
    { return "Полный список дополнительных описаний."; }

    /*! This is an introduction to the page with the list of class/file groups */
    OGString trModulesDescription() override
    { return "Полный список групп."; }

    // index titles (the project name is prepended for these)


    /*! This is used in HTML as the title of index.html. */
    OGString trDocumentation(const OGString &projName) override
    { return (!projName.isEmpty()?projName + " " : "") + "Документация"; }

    /*! This is used in LaTeX as the title of the chapter with the
     * index of all groups.
     */
    OGString trModuleIndex() override
    { return "Алфавитный указатель групп"; }

    /*! This is used in LaTeX as the title of the chapter with the
     * class hierarchy.
     */
    OGString trHierarchicalIndex() override
    { return "Иерархический список классов"; }

    /*! This is used in LaTeX as the title of the chapter with the
     * annotated compound index.
     */
    OGString trCompoundIndex() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Алфавитный указатель структур данных";
      }
      else
      {
        return "Алфавитный указатель классов";
      }
    }

    /*! This is used in LaTeX as the title of the chapter with the
     * list of all files.
     */
    OGString trFileIndex() override
    { return "Список файлов"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all groups.
     */
    OGString trModuleDocumentation() override
    { return "Группы"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all classes, structs and unions.
     */
    OGString trClassDocumentation() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Структуры данных";
      }
      else if (Config_getBool(OPTIMIZE_OUTPUT_VHDL))
      {
          return trDesignUnitDocumentation();
      }
      else
      {
        return "Классы";
      }
    }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all files.
     */
    OGString trFileDocumentation() override
    { return "Файлы"; }

    /*! This is used in LaTeX as the title of the document */
    OGString trReferenceManual() override
    { return "Оглавление"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of defines
     */
    OGString trDefines() override
    { return "Макросы"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of typedefs
     */
    OGString trTypedefs() override
    { return "Определения типов"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of enumerations
     */
    OGString trEnumerations() override
    { return "Перечисления"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) functions
     */
    OGString trFunctions() override
    { return "Функции"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) variables
     */
    OGString trVariables() override
    { return "Переменные"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) variables
     */
    OGString trEnumerationValues() override
    { return "Элементы перечислений"; }

    /*! This is used in the documentation of a file before the list of
     *  documentation blocks for defines
     */
    OGString trDefineDocumentation() override
    { return "Макросы"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for typedefs
     */
    OGString trTypedefDocumentation() override
    { return "Типы"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for enumeration types
     */
    OGString trEnumerationTypeDocumentation() override
    { return "Перечисления"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for functions
     */
    OGString trFunctionDocumentation() override
    { return "Функции"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for variables
     */
    OGString trVariableDocumentation() override
    { return "Переменные"; }

    /*! This is used in the documentation of a file/namespace/group before
     *  the list of links to documented compounds
     */
    OGString trCompounds() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Структуры данных";
      }
      else
      {
        return "Классы";
      }

    }

    /*! This is used in the documentation of a group before the list of
     *  links to documented files
     */
    /*! This is used in the standard footer of each page and indicates when
     *  the page was generated
     */
    OGString trGeneratedAt(const OGString &date,const OGString &projName) override
    {
      OGString result="Документация ";
      if (!projName.isEmpty()) result+=OGString("по ")+projName;
      result+=OGString(". Последние изменения: ")+date;
      result+=". Создано системой";
      return result;
    }

    /*! this text is put before a class diagram */
    OGString trClassDiagram(const OGString &clName) override
    {
      return OGString("Граф наследования:")+clName+":";
    }

    /*! this text is generated when the \\warning command is used. */
    OGString trWarning() override
    { return "Предупреждения"; }

    /*! this text is generated when the \\version command is used. */
    OGString trVersion() override
    { return "Версия"; }

    /*! this text is generated when the \\date command is used. */
    OGString trDate() override
    { return "Дата"; }

    /*! this text is generated when the \\return command is used. */
    OGString trReturns() override
    { return "Возвращает"; }

    /*! this text is generated when the \\sa command is used. */
    OGString trSeeAlso() override
    { return "См. также"; }

    /*! this text is generated when the \\param command is used. */
    OGString trParameters() override
    { return "Аргументы"; }

    /*! this text is generated when the \\exception command is used. */
    OGString trExceptions() override
    { return "Исключения"; }

    /*! this text is used in the title page of a LaTeX document. */
    OGString trGeneratedBy() override
    { return "Создано системой"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990307
//////////////////////////////////////////////////////////////////////////

    /*! used as the title of page containing all the index of all namespaces. */
    OGString trNamespaceList() override
    { return "Пространства имен"; }

    /*! used as an introduction to the namespace list */
    OGString trNamespaceListDescription(bool extractAll) override
    {
      OGString result="Полный список ";
      if (!extractAll) result+="документированных ";
      result+="пространств имен.";
      return result;
    }

    /*! used in the class documentation as a header before the list of all
     *  friends of a class
     */
    OGString trFriends() override
    { return "Друзья"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990405
//////////////////////////////////////////////////////////////////////////

    /*! used in the class documentation as a header before the list of all
     * related classes
     */
    OGString trRelatedFunctionDocumentation() override
    { return "Документация по друзьям класса и функциям, относящимся"
        " к классу"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990425
//////////////////////////////////////////////////////////////////////////

    /*! used as the title of the HTML page of a class/struct/union */
    OGString trCompoundReference(const OGString &clName,
                                 ClassDef::CompoundType compType,
                                 bool isTemplate) override
    {
      OGString result;
      if (isTemplate)
      {
        result="Шаблон ";
        switch(compType)
        {
          case ClassDef::Class:  result+="класса"; break;
          case ClassDef::Struct: result+="структуры"; break;
          case ClassDef::Union:  result+="объединения"; break;
          case ClassDef::Interface:  result+="интерфейса"; break;
          case ClassDef::Protocol:   result+="протокола"; break;
          case ClassDef::Category:   result+="категории"; break;
          case ClassDef::Exception:  result+="исключения"; break;
          default: break;
        }
      }
      else
      {
        switch(compType)
        {
          case ClassDef::Class:  result+="Класс"; break;
          case ClassDef::Struct: result+="Структура"; break;
          case ClassDef::Union:  result+="Объединение"; break;
          case ClassDef::Interface:  result+="Интерфейс"; break;
          case ClassDef::Protocol:   result+="Протокол"; break;
          case ClassDef::Category:   result+="Категория"; break;
          case ClassDef::Exception:  result+="Исключение"; break;
          default: break;
        }
      }
      result+=" ";
      return result+clName;
    }

    /*! used as the title of the HTML page of a file */
    OGString trFileReference(const OGString &fileName) override
    {
      return OGString("Файл ")+fileName;
    }

    /*! used as the title of the HTML page of a namespace */
    OGString trNamespaceReference(const OGString &namespaceName) override
    {
      return OGString("Пространство имен ")+namespaceName;
    }

    OGString trPublicMembers() override
    { return "Открытые члены"; }
    OGString trPublicSlots() override
    { return "Открытые слоты"; }
    OGString trSignals() override
    { return "Сигналы"; }
    OGString trStaticPublicMembers() override
    { return "Открытые статические члены"; }
    OGString trProtectedMembers() override
    { return "Защищенные члены"; }
    OGString trProtectedSlots() override
    { return "Защищенные слоты"; }
    OGString trStaticProtectedMembers() override
    { return "Защищенные статические члены"; }
    OGString trPrivateMembers() override
    { return "Закрытые члены"; }
    OGString trPrivateSlots() override
    { return "Закрытые слоты"; }
    OGString trStaticPrivateMembers() override
    { return "Закрытые статические члены"; }

    /*! this function is used to produce a comma-separated list of items.
     *  use generateMarker(i) to indicate where item i should be put.
     */
    OGString trWriteList(int numEntries) override
    {
      OGString result;
      // the inherits list contain `numEntries' classes
      for (int i=0;i<numEntries;i++)
      {
        // use generateMarker to generate placeholders for the class links!
        result+=generateMarker(i); // generate marker for entry i in the list
                                   // (order is left to right)

        if (i!=numEntries-1)  // not the last entry, so we need a separator
        {
          if (i<numEntries-2) // not the fore last entry
            result+=", ";
          else                // the fore last entry
            result+=" и ";
        }
      }
      return result;
    }

    /*! used in class documentation to produce a list of base classes,
     *  if class diagrams are disabled.
     */
    OGString trInheritsList(int numEntries) override
    {
      return "Базовые классы:"+trWriteList(numEntries)+".";
    }

    /*! used in class documentation to produce a list of super classes,
     *  if class diagrams are disabled.
     */
    OGString trInheritedByList(int numEntries) override
    {
      return "Производные классы:"+trWriteList(numEntries)+".";
    }

    /*! used in member documentation blocks to produce a list of
     *  members that are hidden by this one.
     */
    OGString trReimplementedFromList(int numEntries) override
    {
      OGString result="Переопределяет метод";
      if(numEntries>1)
	result+="ы предков";
      else
	result+=" предка";
      return result+" "+trWriteList(numEntries)+".";
    }

    /*! used in member documentation blocks to produce a list of
     *  all member that overwrite the implementation of this member.
     */
    OGString trReimplementedInList(int numEntries) override
    {
      return "Переопределяется в "+trWriteList(numEntries)+".";
    }

    /*! This is put above each page as a link to all members of namespaces. */
    OGString trNamespaceMembers() override
    { return "Члены пространств имен"; }

    /*! This is an introduction to the page with all namespace members */
    OGString trNamespaceMemberDescription(bool extractAll) override
    {
      OGString result="Полный список ";
      if (!extractAll) result+="документированных ";
      result+="членов простанств имен.";
      return result;
    }

    /*! This is used in LaTeX as the title of the chapter with the
     *  index of all namespaces.
     */
    OGString trNamespaceIndex() override
    { return "Алфавитный указатель пространств имен"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all namespaces.
     */
    OGString trNamespaceDocumentation() override
    { return "Пространства имен"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990522
//////////////////////////////////////////////////////////////////////////

    /*! This is used in the documentation before the list of all
     *  namespaces in a file.
     */
    OGString trNamespaces() override
    { return "Пространства имен"; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990728
//////////////////////////////////////////////////////////////////////////

    /*! This is put at the bottom of a class documentation page and is
     *  followed by a list of files that were used to generate the page.
     */
    OGString trGeneratedFromFiles(ClassDef::CompoundType compType,
        bool single) override
    { // here s is one of " Class", " Struct" or " Union"
      // single is true implies a single file
      OGString result=OGString("Объявления и описания членов ");
      switch(compType)
      {
        case ClassDef::Class:      result+="класс";
          if (single) result+="а"; else result+="ов";
          break;
        case ClassDef::Struct:     result+="структур";
          if (single) result+="ы";
          break;
        case ClassDef::Union:      result+="объединени";
          if (single) result+="я"; else result+="й";
          break;
        case ClassDef::Interface:  result+="интерфейс";
          if (single) result+="а"; else result+="ов";
          break;
        case ClassDef::Protocol:  result+="протокол";
          if (single) result+="а"; else result+="ов";
          break;
        case ClassDef::Category:  result+="категори";
          if (single) result+="и"; else result+="й";
          break;
        case ClassDef::Exception:  result+="исключени";
          if (single) result+="я"; else result+="й";
          break;
        default:
          break;
      }
      result+=" находятся в файл";
      if (single) result+="е:"; else result+="ах:";
      return result;
    }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-990901
//////////////////////////////////////////////////////////////////////////

    /*! This is used as the heading text for the retval command. */
    OGString trReturnValues() override
    { return "Возвращаемые значения"; }

    /*! This is in the (quick) index as a link to the main page (index.html)
     */
    OGString trMainPage() override
    { return "Титульная страница"; }

    /*! This is used in references to page that are put in the LaTeX
     *  documentation. It should be an abbreviation of the word page.
     */
    OGString trPageAbbreviation() override
    { return "стр."; }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-991106
//////////////////////////////////////////////////////////////////////////

    OGString trDefinedAtLineInSourceFile() override
    {
      return "См. определение в файле @1 строка @0";
    }
    OGString trDefinedInSourceFile() override
    {
      return "См. определение в файле @0";
    }

//////////////////////////////////////////////////////////////////////////
// new since 0.49-991205
//////////////////////////////////////////////////////////////////////////

    OGString trDeprecated() override
    {
      return "Уст.";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.0.0
//////////////////////////////////////////////////////////////////////////

    /*! this text is put before a collaboration diagram */
    OGString trCollaborationDiagram(const OGString &clName) override
    {
      return "Граф связей класса "+clName+":";
    }
    /*! this text is put before an include dependency graph */
    OGString trInclDepGraph(const OGString &fName) override
    {
      return "Граф включаемых заголовочных файлов для "+fName+":";
    }
    /*! header that is put before the list of constructor/destructors. */
    OGString trConstructorDocumentation() override
    {
      return "Конструктор(ы)";
    }
    /*! Used in the file documentation to point to the corresponding sources. */
    OGString trGotoSourceCode() override
    {
      return "См. исходные тексты.";
    }
    /*! Used in the file sources to point to the corresponding documentation. */
    OGString trGotoDocumentation() override
    {
      return "См. документацию.";
    }
    /*! Text for the \\pre command */
    OGString trPrecondition() override
    {
      return "Предусловие";
    }
    /*! Text for the \\post command */
    OGString trPostcondition() override
    {
      return "Постусловие";
    }
    /*! Text for the \\invariant command */
    OGString trInvariant() override
    {
      return "Инвариант";
    }
    /*! Text shown before a multi-line variable/enum initialization */
    OGString trInitialValue() override
    {
      return "Инициализатор";
    }
    /*! Text used the source code in the file index */
    OGString trCode() override
    {
      return "Исходные тексты";
    }
    OGString trGraphicalHierarchy() override
    {
      return "Иерархия классов. Графический вид.";
    }
    OGString trGotoGraphicalHierarchy() override
    {
      return "см. графический вид.";
    }
    OGString trGotoTextualHierarchy() override
    {
      return "см. текстовый вид.";
    }
    OGString trPageIndex() override
    {
      return "Алфавитный указатель тематических описаний";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.0
//////////////////////////////////////////////////////////////////////////

    OGString trNote() override
    {
      return "Заметки";
    }
    OGString trPublicTypes() override
    {
      return "Открытые типы";
    }
    OGString trPublicAttribs() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Поля данных";
      }
      else
      {
        return "Открытые атрибуты";
      }
    }
    OGString trStaticPublicAttribs() override
    {
      return "Статические открытые данные";
    }
    OGString trProtectedTypes() override
    {
      return "Защищенные типы";
    }
    OGString trProtectedAttribs() override
    {
      return "Защищенные данные";
    }
    OGString trStaticProtectedAttribs() override
    {
      return "Статические защищенные данные";
    }
    OGString trPrivateTypes() override
    {
      return "Закрытые типы";
    }
    OGString trPrivateAttribs() override
    {
      return "Закрытые данные";
    }
    OGString trStaticPrivateAttribs() override
    {
      return "Закрытые статические данные";
    }


//////////////////////////////////////////////////////////////////////////
// new since 1.1.3
//////////////////////////////////////////////////////////////////////////

    /*! Used as a marker that is put before a todo item */
    OGString trTodo() override
    /*??*/
    {
      return "Необходимо сделать";
    }
    /*! Used as the header of the todo list */
    OGString trTodoList() override
    /*??*/
    {
      return "Список задач";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.4
//////////////////////////////////////////////////////////////////////////

    OGString trReferencedBy() override
    {
      return "Используется в";
    }
    OGString trRemarks() override
    {
      return "Прим.";
    }
    OGString trAttention() override
    {
      return "Внимание";
    }
    OGString trInclByDepGraph() override
    {
      return "Граф файлов, в которые включается этот файл:";
    }
    OGString trSince() override
    /*??*/
    {
      return "Начиная с";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.1.5
//////////////////////////////////////////////////////////////////////////

    /*! title of the graph legend page */
    OGString trLegendTitle() override
    {
      return "Легенда";
    }
    /*! page explaining how the dot graph's should be interpreted */
    OGString trLegendDocs() override
    {
      return
        "Обозначения, используемые в графах.<p>\n"
        "Рассмотрим следующий пример:\n"
        "\\code\n"
        "/*! Невидимый класс из-за усечения */\n"
        "class Invisible { };\n\n"
        "/*! Усеченный класс, отношение наследования скрыто */\n"
        "class Truncated : public Invisible { };\n\n"
        "/* Недокументированный класс */\n"
        "class Undocumented { };\n\n"
        "/*! Открытое наследование */\n"
        "class PublicBase : public Truncated { };\n\n"
        "/*! Шаблон класса */\n"
        "template<class T> class Templ {};\n\n"
        "/*! Защищенное наследование */\n"
        "class ProtectedBase { };\n\n"
        "/*! Закрытое наследование */\n"
        "class PrivateBase { };\n\n"
        "/*! Класс, используемый классом Inherited */\n"
        "class Used { };\n\n"
        "/*! Класс, порожденный от других классов */\n"
        "class Inherited : public PublicBase,\n"
        "                  protected ProtectedBase,\n"
        "                  private PrivateBase,\n"
        "                  public Undocumented,\n"
        "                  public Templ<int>\n"
        "{\n"
        "  private:\n"
        "    Used *m_usedClass;\n"
        "};\n"
        "\\endcode\n"
        "Получится следующий граф:"
        "<p><center><img src=\"graph_legend."+getDotImageExtension()+"\"></center>\n"
        "<p>\n"
        "Прямоугольники в этом графе имеют следующее значение:\n"
        "<ul>\n"
        "<li>Заполненный черный прямоугольник представляет структуру или класс, "
        "для которого создан граф.\n"
        "<li>Прямоугольник с черной границей обозначает документированную структуру или класс.\n"
        "<li>Прямоугольник с серой границей обозначает недокументированную структуру или класс.\n"
        "<li>Прямоугольник с красной границей обозначает документированную структуру или класс, для которого\n"
        " не все отношения наследования/содержания показаны. Граф усечен, "
        "если он не поместился в указанных границах.\n"
        "</ul>\n"
        "Стрелки имеют следующее значение:\n"
        "<ul>\n"
        "<li>Темно-синяя стрелка используется для изображения отношения открытого наследования "
        "между двумя классами.\n"
        "<li>Темно-зеленая стрелка используется при защищенном наследовании.\n"
        "<li>Темно-красная стрелка используется при закрытом наследовании.\n"
        "<li>Фиолетовая стрелка используется, если класс содержится в"
        "другом класе или используется другим классом."
        "Со стрелкой указывается переменная, "
        "через которую доступен указываемый класс или структура. \n"
        "<li>Желтая стрелка используется для связи подстановки шаблона и "
        "шаблона, на основе которого эта подстановка выполнена. С шаблоном"
        "указывается параметр подстановки.\n"
        "</ul>\n";
    }
    /*! text for the link to the legend page */
    OGString trLegend() override
    {
      return "см. легенду";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.0
//////////////////////////////////////////////////////////////////////////

    /*! Used as a marker that is put before a test item */
    OGString trTest() override
    {
      return "Тест";
    }
    /*! Used as the header of the test list */
    OGString trTestList() override
    {
      return "Список тестов";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.2
//////////////////////////////////////////////////////////////////////////

    /*! Used as a section header for IDL properties */
    OGString trProperties() override
    {
      return "Свойства";
    }
    /*! Used as a section header for IDL property documentation */
    OGString trPropertyDocumentation() override
    {
      return "Полный список свойств";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.4
//////////////////////////////////////////////////////////////////////////

    /*! Used for Java classes in the summary section of Java packages */
    OGString trClasses() override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        return "Структуры данных";
      }
      else
      {
        return "Классы";
      }
    }
    /*! Used as the title of a Java package */
    OGString trPackage(const OGString &name) override
    {
      return OGString("Пакет ")+name;
    }
    /*! The description of the package index page */
    OGString trPackageListDescription() override
    {
      return "Полный список документированных пакетов.";
    }
    /*! The link name in the Quick links header for each page */
    OGString trPackages() override
    {
      return "Пакеты";
    }
    /*! Text shown before a multi-line define */
    OGString trDefineValue() override
    {
      return "Макроопределение:";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.5
//////////////////////////////////////////////////////////////////////////

    /*! Used as a marker that is put before a \\bug item */
    OGString trBug() override
    {
      return "Ошибка";
    }
    /*! Used as the header of the bug list */
    OGString trBugList() override
    {
      return "Ошибки";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.6
//////////////////////////////////////////////////////////////////////////
    /*! Used as ansicpg for RTF file */
    OGString trRTFansicp() override
    {
      return "1251";
    }
    /*! Used as ansicpg for RTF fcharset */
    OGString trRTFCharSet() override
    {
      return "204";
    }
    /*! Used as header RTF general index */
    OGString trRTFGeneralIndex() override
    {
      return "Алфавитный указатель";
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trClass(bool first_capital, bool singular) override
    {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C))
      {
        OGString result((first_capital ? "Структуры данных" : "структуры данных"));
        return result;
      }
      else
      {
      return createNoun(first_capital, singular, "класс", "ы");
      }
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trFile(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "файл", "ы");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trNamespace(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "пространств", "а имен", "о имен");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trGroup(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "групп", "ы", "а");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trPage(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "страниц", "ы", "а");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trMember(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "член", "ы");
    }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trGlobal(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "глобальны", "е", "й");
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.7
//////////////////////////////////////////////////////////////////////////

    /*! This text is generated when the \\author command is used and
     *  for the author section in man pages. */
    OGString trAuthor(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "автор", "ы");
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.11
//////////////////////////////////////////////////////////////////////////

    /*! This text is put before the list of members referenced by a member
     */
    OGString trReferences() override
    {
      return "Перекрестные ссылки";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.13
//////////////////////////////////////////////////////////////////////////

    /*! used in member documentation blocks to produce a list of
     *  members that are implemented by this one.
     */
    OGString trImplementedFromList(int numEntries) override
    {
      return "Замещает "+trWriteList(numEntries)+".";
    }

    /*! used in member documentation blocks to produce a list of
     *  all members that implementation this member.
     */
    OGString trImplementedInList(int numEntries) override
    {
      return "Замещается в "+trWriteList(numEntries)+".";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.16
//////////////////////////////////////////////////////////////////////////

    /*! used in RTF documentation as a heading for the Table
     *  of Contents.
     */
    OGString trRTFTableOfContents() override
    {
      return "Оглавление";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.17
//////////////////////////////////////////////////////////////////////////

    /*! Used as the header of the list of item that have been
     *  flagged deprecated
     */
    OGString trDeprecatedList() override
    {
      return "Список устаревших определений и описаний";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.2.18
//////////////////////////////////////////////////////////////////////////

    /*! Used as a header for declaration section of the events found in
     * a C# program
     */
    OGString trEvents() override
    {
      return "События";
    }
    /*! Header used for the documentation section of a class' events. */
    OGString trEventDocumentation() override
    {
      return "Cобытия";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3
//////////////////////////////////////////////////////////////////////////

    /*! Used as a heading for a list of Java class types with package scope.
     */
    OGString trPackageTypes() override
    {
      return "Типы с областью видимости пакета";
    }
    /*! Used as a heading for a list of Java class functions with package
     * scope.
     */
    OGString trPackageFunctions() override
    {
      return "Функции с областью видимости пакета";
    }
    OGString trPackageMembers() override
    {
      return "Члены с областью видимости пакета";
    }
    /*! Used as a heading for a list of static Java class functions with
     *  package scope.
     */
    OGString trStaticPackageFunctions() override
    {
      return "Статические функции с областью видимости пакета";
    }
    /*! Used as a heading for a list of Java class variables with package
     * scope.
     */
    OGString trPackageAttribs() override
    {
      return "Переменные с областью видимости пакета";
    }
    /*! Used as a heading for a list of static Java class variables with
     * package scope.
     */
    OGString trStaticPackageAttribs() override
    {
      return "Статические переменные с областью видимости пакета";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.1
//////////////////////////////////////////////////////////////////////////

    /*! Used in the quick index of a class/file/namespace member list page
     *  to link to the unfiltered list of all members.
     */
    OGString trAll() override
    {
      return "Указатель";
    }
    /*! Put in front of the call graph for a function. */
    OGString trCallGraph() override
    {
      return "Граф вызовов:";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.3
//////////////////////////////////////////////////////////////////////////

    /*! This string is used as the title for the page listing the search
     *  results.
     */
    OGString trSearchResultsTitle() override
    {
      return "Результаты поиска";
    }
    /*! This string is put just before listing the search results. The
     *  text can be different depending on the number of documents found.
     *  Inside the text you can put the special marker $num to insert
     *  the number representing the actual number of search results.
     *  The @a numDocuments parameter can be either 0, 1 or 2, where the
     *  value 2 represents 2 or more matches. HTML markup is allowed inside
     *  the returned string.
     */
    OGString trSearchResults(int numDocuments) override
    {
      if (numDocuments==0)
      {
        return "К сожалению, по Вашему запросу ничего не найдено.";
      }
      else if( numDocuments == 1 )
      {
        return "Найден 1 документ.";
      }
      else
      {
        return "Найден(о) <b>$num</b> документ(ов). "
          "Документы отсортированы по релевантности.";
      }
    }
    /*! This string is put before the list of matched words, for each search
     *  result. What follows is the list of words that matched the query.
     */
    OGString trSearchMatches() override
    {
      return "Найдено:";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.8
//////////////////////////////////////////////////////////////////////////

    /*! This is used in HTML as the title of page with source code for file filename
     */
    OGString trSourceFile(const OGString& filename) override
    {
      return "Исходный файл " + filename;
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.3.9
//////////////////////////////////////////////////////////////////////////

    /*! This is used as the name of the chapter containing the directory
     *  hierarchy.
     */
    OGString trDirIndex() override
    { return "Дерево директорий"; }

    /*! This is used as the name of the chapter containing the documentation
     *  of the directories.
     */
    OGString trDirDocumentation() override
    { return "Директории"; }

    /*! This is used as the title of the directory index and also in the
     *  Quick links of a HTML page, to link to the directory hierarchy.
     */
    OGString trDirectories() override
    { return "Алфавитный указатель директорий"; }

    /*! This returns the title of a directory page. The name of the
     *  directory is passed via \a dirName.
     */
    OGString trDirReference(const OGString &dirName) override
    { OGString result=OGString("Содержание директории ")+ dirName; return result; }

    /*! This returns the word directory with or without starting capital
     *  (\a first_capital) and in sigular or plural form (\a singular).
     */
    OGString trDir(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "директори", "и", "я");
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.4.1
//////////////////////////////////////////////////////////////////////////

    /*! This text is added to the documentation when the \\overload command
     *  is used for a overloaded function.
     */
    OGString trOverloadText() override
    {
       return "Эта функция перегружена и предоставляется исключительно "
              "для удобства использования. Она отличается от вышеупомянутой "
              "только фактическими аргументами.";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.4.6
//////////////////////////////////////////////////////////////////////////

    /*! This is used to introduce a caller (or called-by) graph */
    OGString trCallerGraph() override
    {
      return "Граф вызова функции:";
    }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for enumeration values
     */
    OGString trEnumerationValueDocumentation() override
    { return "Элементы перечислений"; }


//////////////////////////////////////////////////////////////////////////
// new since 1.5.4 (mainly for Fortran)
//////////////////////////////////////////////////////////////////////////
    // Простите переводчика, уже лет 20 не писал на фортране...
    // Любые замечания приму с благодарностью.

    /*! header that is put before the list of member subprograms (Fortran). */
    OGString trMemberFunctionDocumentationFortran() override
    { return "Функции/подпрограммы"; }

    /*! This is put above each page as a link to the list of annotated data types (Fortran). */
    OGString trCompoundListFortran() override
    { return "Типы данных"; }

    /*! This is put above each page as a link to all members of compounds (Fortran). */
    OGString trCompoundMembersFortran() override
    { return "Поля данных"; }

    /*! This is an introduction to the annotated compound list (Fortran). */
    OGString trCompoundListDescriptionFortran() override
    { return "Аннотированный список типов данных:"; }

    /*! This is an introduction to the page with all data types (Fortran). */
    OGString trCompoundMembersDescriptionFortran(bool extractAll) override
    {
      OGString result="Список всех ";
      if (!extractAll)
      {
        result+="документированных ";
      }
      result+="членов типа со ссылками ";
      if (!extractAll)
      {
	result+="на документацию для каждого члена:";
      }
      else
      {
         result+="на содержащую структуру:";
      }
      return result;
    }

    /*! This is used in LaTeX as the title of the chapter with the
     * annotated compound index (Fortran).
     */
    OGString trCompoundIndexFortran() override
    { return "Типы данных"; }

    /*! This is used in LaTeX as the title of the chapter containing
     *  the documentation of all data types (Fortran).
     */
    OGString trTypeDocumentation() override
    { return "Оглавление типов данных"; }

    /*! This is used in the documentation of a file as a header before the
     *  list of (global) subprograms (Fortran).
     */
    OGString trSubprograms() override
    { return "Функции/подпрограммы"; }

    /*! This is used in the documentation of a file/namespace before the list
     *  of documentation blocks for subprograms (Fortran)
     */
    OGString trSubprogramDocumentation() override
    { return "Функции/подпрограммы"; }

    /*! This is used in the documentation of a file/namespace/group before
     *  the list of links to documented compounds (Fortran)
     */
     OGString trDataTypes() override
    { return "Типы данных"; }

    /*! used as the title of page containing all the index of all modules (Fortran). */
    OGString trModulesList() override
    { return "Указатель модулей"; }

    /*! used as an introduction to the modules list (Fortran) */
    OGString trModulesListDescription(bool extractAll) override
    {
      OGString result="Аннотированный список";
      if (!extractAll) result+="документированных ";
      result+="модулей:";
      return result;
    }

    /*! used as the title of the HTML page of a module/type (Fortran) */
    OGString trCompoundReferenceFortran(const OGString &clName,
                                    ClassDef::CompoundType compType,
                                    bool isTemplate) override
    {
      OGString result=clName;
      if (isTemplate)
      {
	switch(compType)
	{
	  case ClassDef::Class:      result+=" Модуль"; break;
	  case ClassDef::Struct:     result+=" Тип"; break;
	  case ClassDef::Union:      result+=" Объединение"; break;
	  case ClassDef::Interface:  result+=" Интерфейс"; break;
	  case ClassDef::Protocol:   result+=" Протокол"; break;
	  case ClassDef::Category:   result+=" Категория"; break;
	  case ClassDef::Exception:  result+=" Исключение"; break;
          default: break;
	}
      }
      else
      {
	result+=" Шаблон ";
	switch(compType)
	{
	  case ClassDef::Class:      result+="модуля"; break;
	  case ClassDef::Struct:     result+="типа"; break;
	  case ClassDef::Union:      result+="объединения"; break;
	  case ClassDef::Interface:  result+="интерфейса"; break;
	  case ClassDef::Protocol:   result+="протокола"; break;
	  case ClassDef::Category:   result+="категории"; break;
	  case ClassDef::Exception:  result+="исключения"; break;
          default: break;
	}
      }
      return result;
    }
    /*! used as the title of the HTML page of a module (Fortran) */
    OGString trModuleReference(const OGString &namespaceName) override
    {
      return OGString("Модуль ") + namespaceName;
    }

    /*! This is put above each page as a link to all members of modules. (Fortran) */
    OGString trModulesMembers() override
    { return "Члены модуля"; }

    /*! This is an introduction to the page with all modules members (Fortran) */
    OGString trModulesMemberDescription(bool extractAll) override
    {
      OGString result="Список всех ";
      if (!extractAll) result+="документированных ";
      result+="модулей со ссылками ";
      if (extractAll)
      {
        result+="на документацию для каждого члена:";
      }
      else
      {
        result+="на модули, их содержащие:";
      }
      return result;
    }

    /*! This is used in LaTeX as the title of the chapter with the
     *  index of all modules (Fortran).
     */
    OGString trModulesIndex() override
    { return "Указатель модулей"; }

    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trModule(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "модул", "и", "ь");
    }
    /*! This is put at the bottom of a module documentation page and is
     *  followed by a list of files that were used to generate the page.
     */
    OGString trGeneratedFromFilesFortran(ClassDef::CompoundType compType,
        bool single) override
    { // here s is one of " Module", " Struct" or " Union"
      // single is true implies a single file
      OGString result="Документация по ";
      switch(compType)
      {
        case ClassDef::Class:      result+="модулю"; break;
        case ClassDef::Struct:     result+="типу"; break;
        case ClassDef::Union:      result+="объединению"; break;
        case ClassDef::Interface:  result+="интерфейсу"; break;
        case ClassDef::Protocol:   result+="протоколу"; break;
        case ClassDef::Category:   result+="категории"; break;
        case ClassDef::Exception:  result+="исключению"; break;
        default: break;
      }
      result+=" сгенерирована на основе следующ";
      if (single) result+="его файла:"; else result+="их файлов:";
      return result;
    }
    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trType(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "тип", "ы");
    }
    /*! This is used for translation of the word that will possibly
     *  be followed by a single name or by a list of names
     *  of the category.
     */
    OGString trSubprogram(bool first_capital, bool singular) override
    {
      return createNoun(first_capital, singular, "подпрограмм", "ы", "а");
    }

    /*! C# Type Constraint list */
    OGString trTypeConstraints() override
    {
      return "Согласование типов";
    }
//////////////////////////////////////////////////////////////////////////
// new since 1.6.0 (mainly for the new search engine)
//////////////////////////////////////////////////////////////////////////

    /*! directory relation for \a name */
    OGString trDirRelation(const OGString &name) override
    {
      return OGString(name)+" Связь";
    }

    /*! Loading message shown when loading search results */
    OGString trLoading() override
    {
      return "Загрузка...";
    }

    /*! Label used for search results in the global namespace */
    OGString trGlobalNamespace() override
    {
      return "Глобальное пространство имён";
    }

    /*! Message shown while searching */
    OGString trSearching() override
    {
      return "Поиск...";
    }

    /*! Text shown when no search results are found */
    OGString trNoMatches() override
    {
      return "Не найдено";
    }

//////////////////////////////////////////////////////////////////////////
// new since 1.6.3 (missing items for the directory pages)
//////////////////////////////////////////////////////////////////////////

    /*! when clicking a directory dependency label, a page with a
     *  table is shown. The heading for the first column mentions the
     *  source file that has a relation to another file.
     */
    OGString trFileIn(const OGString &name) override
    {
      return "Файл в "+name;
    }

    /*! when clicking a directory dependency label, a page with a
     *  table is shown. The heading for the second column mentions the
     *  destination file that is included.
     */
    OGString trIncludesFileIn(const OGString &name) override
    {
      return "Включает файл в "+name;
    }

    /** Compiles a date string.
     *  @param year Year in 4 digits
     *  @param month Month of the year: 1=January
     *  @param day Day of the Month: 1..31
     *  @param dayOfWeek Day of the week: 1=Monday..7=Sunday
     *  @param hour Hour of the day: 0..23
     *  @param minutes Minutes in the hour: 0..59
     *  @param seconds Seconds within the minute: 0..59
     *  @param includeTime Include time in the result string?
     */
    OGString trDateTime(int year,int month,int day,int dayOfWeek,
                                int hour,int minutes,int seconds,
                                DateTimeType includeTime) override
    {
      static const char *days[]   = { "Пн","Вт","Ср","Чт","Пт","Сб","Вс" };
      static const char *months[] = { "Янв","Фев","Мар","Апр","Май","Июн","Июл","Авг","Сен","Окт","Ноя","Дек" };
      OGString sdate;
      if (includeTime == DateTimeType::DateTime || includeTime == DateTimeType::Date)
      {
        sdate.sprintf("%s %d %s %d",days[dayOfWeek-1],day,months[month-1],year);
      }
      if (includeTime == DateTimeType::DateTime) sdate += " ";
      if (includeTime == DateTimeType::DateTime || includeTime == DateTimeType::Time)
      {
        OGString stime;
        stime.sprintf("%.2d:%.2d:%.2d",hour,minutes,seconds);
        sdate+=stime;
      }
      return sdate;
    }
    OGString trDayOfWeek(int dayOfWeek, bool, bool full) override
    {
      static const char *days_short[]   = { "Пн", "Вт", "Ср", "Чт", "Пт", "Сб", "Вс" };
      static const char *days_full[]    = { "понедельник", "вторник", "среда", "четверг", "пятница", "суббота", "воскресенье" };
      OGString text  = full? days_full[dayOfWeek-1] : days_short[dayOfWeek-1];
      return text;
    }
    OGString trMonth(int month, bool, bool full) override
    {
      static const char *months_short[] = { "янв", "фев", "мар", "апр", "май", "июн", "июл", "авг", "сен", "окт", "ноя", "дек" };
      static const char *months_full[]  = { "Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь" };
      OGString text  = full? months_full[month-1] : months_short[month-1];
      return text;
    }
    OGString trDayPeriod(bool period) override
    {
      static const char *dayPeriod[] = { "AM", "PM" };
      return dayPeriod[period?1:0];
    }

///////////////////////////////////////////////////////////////////////
// new since 1.7.5
///////////////////////////////////////////////////////////////////////

    /*! Header for the page with bibliographic citations */
    OGString trCiteReferences() override
    { return "Библиографические ссылки"; }

    /*! Text for copyright paragraph */
    OGString trCopyright() override
    { return "Авторство"; }

    /*! Header for the graph showing the directory dependencies */
    OGString trDirDepGraph(const OGString &name) override
    { return OGString("Директория графа зависимостей ")+name+":"; }

///////////////////////////////////////////////////////////////////////
// new since 1.8.0
///////////////////////////////////////////////////////////////////////

    /*! Detail level selector shown for hierarchical indices */
    OGString trDetailLevel() override
    { return "уровень детализации"; }

    /*! Section header for list of template parameters */
    OGString trTemplateParameters() override
    { return "Параметры шаблона"; }

    /*! Used in dot graph when UML_LOOK is enabled and there are many fields */
    OGString trAndMore(const OGString &number) override
    { return "и "+number+" больше..."; }

    /*! Used file list for a Java enum */
    OGString trEnumGeneratedFromFiles(bool single) override
    { OGString result = "Документация для этого перечисления сгенерерирована из файл";
      if (!single) result += "ов";
      result+="а:";
      return result;
    }

    /*! Header of a Java enum page (Java enums are represented as classes). */
    OGString trEnumReference(const OGString &name) override
    { return OGString(name)+" Ссылки на перечисление"; }

    /*! Used for a section containing inherited members */
    OGString trInheritedFrom(const OGString &members,const OGString &what) override
    { return OGString(members)+" унаследованные от "+what; }

    /*! Header of the sections with inherited members specific for the
     *  base class(es)
     */
    OGString trAdditionalInheritedMembers() override
    { return "Дополнительные унаследованные члены"; }

///////////////////////////////////////////////////////////////////////
// new since 1.8.2
///////////////////////////////////////////////////////////////////////

    /*! Used as a tooltip for the toggle button that appears in the
     *  navigation tree in the HTML output when GENERATE_TREEVIEW is
     *  enabled. This tooltip explains the meaning of the button.
     */
    OGString trPanelSynchronisationTooltip(bool enable) override
    {
      OGString opt = enable ? "включить" : "выключить";
      return "нажмите на "+opt+" для синхронизации панелей";
    }

    /*! Used in a method of an Objective-C class that is declared in a
     *  a category. Note that the @1 marker is required and is replaced
     *  by a link.
     */
    OGString trProvidedByCategory() override
    {
      return "По группам @0.";
    }

    /*! Used in a method of an Objective-C category that extends a class.
     *  Note that the @1 marker is required and is replaced by a link to
     *  the class method.
     */
    OGString trExtendsClass() override
    {
      return "Расширяет класс @0.";
    }

    /*! Used as the header of a list of class methods in Objective-C.
     *  These are similar to static public member functions in C++.
     */
    OGString trClassMethods() override
    {
      return "Методы класса";
    }

    /*! Used as the header of a list of instance methods in Objective-C.
     *  These are similar to public member functions in C++.
     */
    OGString trInstanceMethods() override
    {
      return "Методы экземпляра";
    }

    /*! Used as the header of the member functions of an Objective-C class.
     */
    OGString trMethodDocumentation() override
    {
      return "Документация метода";
    }

///////////////////////////////////////////////////////////////////////
// new since 1.8.4
///////////////////////////////////////////////////////////////////////

    /** old style UNO IDL services: implemented interfaces */
    OGString trInterfaces() override
    { return "Экспортируемые интерфейсы"; }

    /** old style UNO IDL services: inherited services */
    OGString trServices() override
    { return "Включённые сервисы"; }

    /** UNO IDL constant groups */
    OGString trConstantGroups() override
    { return "Постоянные группы"; }

    /** UNO IDL constant groups */
    OGString trConstantGroupReference(const OGString &namespaceName) override
    {
      OGString result=namespaceName;
      result+=" Ссылка на постоянную группу";
      return result;
    }
    /** UNO IDL service page title */
    OGString trServiceReference(const OGString &sName) override
    {
      OGString result=sName;
      result+=" Ссылка на сервис";
      return result;
    }
    /** UNO IDL singleton page title */
    OGString trSingletonReference(const OGString &sName) override
    {
      OGString result=sName;
      result+=" Ссылка на одиночку";
      return result;
    }
    /** UNO IDL service page */
    OGString trServiceGeneratedFromFiles(bool single) override
    {
      // single is true implies a single file
      OGString result="Документация для этого сервиса "
                                "сгенерирована из следующего файл";
      if (single) result+="а:"; else result+="ов:";
      return result;
    }
    /** UNO IDL singleton page */
    OGString trSingletonGeneratedFromFiles(bool single) override
    {
      // single is true implies a single file
      OGString result="Документация по этому одиночке "
                                "сгенерирована из следующего файл";
      if (single) result+="а:"; else result+="ов:";
      return result;
    }

/*
 * Russian translations for updates since version 1.8.15
 *
 * Aleksei Leshchenko, 2024
 * Github: FrostMonsterSP
 */

  //////////////////////////////////////////////////////////////////////////
  // new since 1.8.15
  //////////////////////////////////////////////////////////////////////////

  /** VHDL design unit hierarchy */
  OGString trDesignUnitHierarchy() override {
    return "Иерархия проектных единиц";
  }
  /** VHDL design unit list */
  OGString trDesignUnitList() override { return "Список проектных единиц"; }
  /** VHDL design unit members */
  OGString trDesignUnitMembers() override {
    return "Компоненты проектной единицы";
  }
  /** VHDL design unit list description */
  OGString trDesignUnitListDescription() override {
    return "Список всех компонентов проектных единиц со ссылками на "
           "проектные единицы, в которые входят:";
  }
  /** VHDL design unit index */
  OGString trDesignUnitIndex() override { return "Указатель проектных единиц"; }
  /** VHDL design units */
  OGString trDesignUnits() override { return "Проектные единицы"; }
  /** VHDL functions/procedures/processes */
  OGString trFunctionAndProc() override { return "Функции/Процедуры/Процессы"; }
  /** VHDL type */
  OGString trVhdlType(VhdlSpecifier type, bool single) override {
    switch (type) {
    case VhdlSpecifier::LIBRARY:
      if (single)
        return "Библиотека";
      else
        return "Библиотеки";
    case VhdlSpecifier::PACKAGE:
      if (single)
        return "Пакет";
      else
        return "Пакеты";
    case VhdlSpecifier::SIGNAL:
      if (single)
        return "Сигнал";
      else
        return "Сигналы";
    case VhdlSpecifier::COMPONENT:
      if (single)
        return "Компонент";
      else
        return "Компоненты";
    case VhdlSpecifier::CONSTANT:
      if (single)
        return "Конатанта";
      else
        return "Константы";
    case VhdlSpecifier::ENTITY:
      if (single)
        return "Единица";
      else
        return "Единицы";
    case VhdlSpecifier::TYPE:
      if (single)
        return "Тип";
      else
        return "Типы";
    case VhdlSpecifier::SUBTYPE:
      if (single)
        return "Подтип";
      else
        return "Подтипы";
    case VhdlSpecifier::FUNCTION:
      if (single)
        return "Функция";
      else
        return "Функции";
    case VhdlSpecifier::RECORD:
      if (single)
        return "Запись";
      else
        return "Записи";
    case VhdlSpecifier::PROCEDURE:
      if (single)
        return "Процедура";
      else
        return "Процедуры";
    case VhdlSpecifier::ARCHITECTURE:
      if (single)
        return "Архитектура";
      else
        return "Архитектуры";
    case VhdlSpecifier::ATTRIBUTE:
      if (single)
        return "Аттрибут";
      else
        return "Аттрибуты";
    case VhdlSpecifier::PROCESS:
      if (single)
        return "Процесс";
      else
        return "Процессы";
    case VhdlSpecifier::PORT:
      if (single)
        return "Порт";
      else
        return "Порты";
    case VhdlSpecifier::USE:
      if (single)
        return "Условие использования";
      else
        return "Условия использования";
    case VhdlSpecifier::GENERIC:
      if (single)
        return "Дженерик";
      else
        return "Дженерики";
    case VhdlSpecifier::PACKAGE_BODY:
      return "Тело пакета";
    case VhdlSpecifier::UNITS:
      return "Единицы";
    case VhdlSpecifier::SHAREDVARIABLE:
      if (single)
        return "Общая переменная";
      else
        return "Общие переменные";
    case VhdlSpecifier::VFILE:
      if (single)
        return "Файл";
      else
        return "Файлы";
    case VhdlSpecifier::GROUP:
      if (single)
        return "Группа";
      else
        return "Группы";
    case VhdlSpecifier::INSTANTIATION:
      if (single)
        return "Созданный экземпляр";
      else
        return "Созданные экземпляры";
    case VhdlSpecifier::ALIAS:
      if (single)
        return "Псевдоним";
      else
        return "Псевдонимы";
    case VhdlSpecifier::CONFIG:
      if (single)
        return "Конфигурация";
      else
        return "Конфигурации";
    case VhdlSpecifier::MISCELLANEOUS:
      return "Разное";
    case VhdlSpecifier::UCF_CONST:
      return "Ограничения";
    default:
      return "Класс";
    }
  }
  OGString trCustomReference(const OGString &name) override {
    return "Документация " + name;
  }

  /* Slice */
  OGString trConstants() override { return "Константы"; }
  OGString trConstantDocumentation() override {
    return "Документация константы";
  }
  OGString trSequences() override { return "Последовательности"; }
  OGString trSequenceDocumentation() override {
    return "Документация последовательности";
  }
  OGString trDictionaries() override { return "Словари"; }
  OGString trDictionaryDocumentation() override {
    return "Документация словаря";
  }
  OGString trSliceInterfaces() override { return "Интерфейсы"; }
  OGString trInterfaceIndex() override { return "Документация интерфейса"; }
  OGString trInterfaceList() override { return "Список интерфейсов"; }
  OGString trInterfaceListDescription() override {
    return "Здесь представлен список интерфейсов с их кратким описанием:";
  }
  OGString trInterfaceHierarchy() override { return "Иерархия интерфейса"; }
  OGString trInterfaceHierarchyDescription() override {
    return "Данный список наследований по большей части, но не "
           "полностью, отсортирован в алфавитном порядке:";
  }
  OGString trInterfaceDocumentation() override {
    return "Документация интерфейса";
  }
  OGString trStructs() override { return "Структуры"; }
  OGString trStructIndex() override { return "Указатель Структур"; }
  OGString trStructList() override { return "Список Структур"; }
  OGString trStructListDescription() override {
    return "Здесь представлен список структур с их краткими описаниями:";
  }
  OGString trStructDocumentation() override { return "Документация структур"; }
  OGString trExceptionIndex() override { return "Указатель исключений"; }
  OGString trExceptionList() override { return "Список исключений"; }
  OGString trExceptionListDescription() override {
    return "Здесь представлен список исключений с их краткими описаниями:";
  }
  OGString trExceptionHierarchy() override { return "Иерархия Исключения"; }
  OGString trExceptionHierarchyDescription() override {
    return "Данный список наследований частично, но не полностью, отсортирован "
           "в алфавитном порядке:";
  }
  OGString trExceptionDocumentation() override {
    return "Документация исключения";
  }
  OGString trCompoundReferenceSlice(const OGString &clName,
                                    ClassDef::CompoundType compType,
                                    bool isLocal) override {
    OGString result = "Ссылка на";
    switch (compType) {
    case ClassDef::Class:
      if (isLocal)
        result += " локальный";
      result += " класс ";
      break;
    case ClassDef::Struct:
      if (isLocal)
        result += " локальную";
      result += " структуру ";
      break;
    case ClassDef::Union:
      if (isLocal)
        result += " локальное";
      result += " объединение ";
      break;
    case ClassDef::Interface:
      if (isLocal)
        result += " локальный";
      result += " интерфейс ";
      break;
    case ClassDef::Protocol:
      if (isLocal)
        result += " локальный";
      result += " протокол ";
      break;
    case ClassDef::Category:
      if (isLocal)
        result += " локальную";
      result += " категорию ";
      break;
    case ClassDef::Exception:
      if (isLocal)
        result += " локальное";
      result += " исключение ";
      break;
    default:
      break;
    }
    return result + clName;
  }
  OGString trOperations() override { return "Операции"; }
  OGString trOperationDocumentation() override {
    return "Документация операции";
  }
  OGString trDataMembers() override { return "Поля класса"; }
  OGString trDataMemberDocumentation() override {
    return "Документация для полей класса";
  }

  //////////////////////////////////////////////////////////////////////////
  // new since 1.8.19
  //////////////////////////////////////////////////////////////////////////

  /** VHDL design unit documentation */
  OGString trDesignUnitDocumentation() override { return "Проектная единица"; }

  //////////////////////////////////////////////////////////////////////////
  // new since 1.9.2
  //////////////////////////////////////////////////////////////////////////

  /** C++20 concept */
  OGString trConcept(bool first_capital, bool singular) override {
    return createNoun(first_capital, singular, "концепт", "ы");
  }
  /*! used as the title of the HTML page of a C++20 concept page */
  OGString trConceptReference(const OGString &conceptName) override {
    return "Ссылка на концепт " + conceptName;
  }

  /*! used as the title of page containing all the index of all concepts. */
  OGString trConceptList() override { return "Список концептов"; }

  /*! used as the title of chapter containing the index listing all concepts. */
  OGString trConceptIndex() override { return "Указатель концептов"; }

  /*! used as the title of chapter containing all information about concepts. */
  OGString trConceptDocumentation() override {
    return "Документация концептов";
  }

  /*! used as an introduction to the concept list */
  OGString trConceptListDescription(bool extractAll) override {
    OGString result = "Список всех  ";
    if (!extractAll)
      result += "задокументированных ";
    result += "концептов с их краткими описаниями:";
    return result;
  }

  /*! used to introduce the definition of the C++20 concept */
  OGString trConceptDefinition() override { return "Определение концепта"; }

  //////////////////////////////////////////////////////////////////////////
  // new since 1.9.4
  //////////////////////////////////////////////////////////////////////////

  OGString trPackageList() override { return "Список пакетов"; }

  //////////////////////////////////////////////////////////////////////////
  // new since 1.9.6
  //////////////////////////////////////////////////////////////////////////

  /*! This is used for translation of the word that will be
   *  followed by a single name of the VHDL process flowchart.
   */
  OGString trFlowchart() override { return "Блок-схема:"; }

  /*! Please translate also updated body of the method
   *  trMemberFunctionDocumentation(), now better adapted for
   *  VHDL sources documentation.
   */

  //////////////////////////////////////////////////////////////////////////
  // new since 1.9.7
  //////////////////////////////////////////////////////////////////////////
  /*! used in the compound documentation before a list of related symbols.
   *
   *  Supersedes trRelatedFunctions
   */
  OGString trRelatedSymbols() override { return "Относящиеся к классу:"; }

  /*! subscript for the related symbols
   *
   *  Supersedes trRelatedSubscript
   */
  OGString trRelatedSymbolsSubscript() override { return "(не члены класса)"; }

  /*! used in the class documentation as a header before the list of all
   * related classes.
   *
   * Supersedes trRelatedFunctionDocumentation
   */
  OGString trRelatedSymbolDocumentation() override {
    return "Друзья класса и относящимся к классу обозначения";
  }

  /*! the compound type as used for the xrefitems */
  OGString trCompoundType(ClassDef::CompoundType compType,
                          SrcLangExt lang) override {
    OGString result;
    switch (compType) {
    case ClassDef::Class:
      if (lang == SrcLangExt::Fortran)
        trType(true, true);
      else
        result = trClass(true, true);
      break;
    case ClassDef::Struct:
      result = "Структура";
      break;
    case ClassDef::Union:
      result = "Объединение";
      break;
    case ClassDef::Interface:
      result = "Интерфейс";
      break;
    case ClassDef::Protocol:
      result = "Протокол";
      break;
    case ClassDef::Category:
      result = "Категория";
      break;
    case ClassDef::Exception:
      result = "Исключение";
      break;
    case ClassDef::Service:
      result = "Служба";
      break;
    case ClassDef::Singleton:
      result = "Синглтон";
      break;
    default:
      break;
    }
    return result;
  }

  OGString
  trFileMembersDescriptionTotal(FileMemberHighlight::Enum hl) override {
    bool extractAll = Config_getBool(EXTRACT_ALL);
    OGString result = "Список всех  ";
    if (!extractAll)
      result += "задокументированных ";

    switch (hl) {
    case FileMemberHighlight::All:
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C)) {
        result += "функций, переменных, макроопределений, перечислителей и "
                  "определений типов";
      } else {
        result += "прикреплённых файлов";
      }
      break;
    case FileMemberHighlight::Functions:
      result += "функций";
      break;
    case FileMemberHighlight::Variables:
      result += "переменных";
      break;
    case FileMemberHighlight::Typedefs:
      result += "определений типов";
      break;
    case FileMemberHighlight::Sequences:
      result += "последовательностей";
      break;
    case FileMemberHighlight::Dictionaries:
      result += "словарей";
      break;
    case FileMemberHighlight::Enums:
      result += "перечислителей";
      break;
    case FileMemberHighlight::EnumValues:
      result += "значений перечислителей";
      break;
    case FileMemberHighlight::Defines:
      result += "макроопределений";
      break;
    case FileMemberHighlight::Total: // for completeness
      break;
    }
    result += " соссылками на ";
    if (extractAll)
      result += "файлы, к которым они относятся:";
    else
      result += "документацию:";
    return result;
  }
  OGString
  trCompoundMembersDescriptionTotal(ClassMemberHighlight::Enum hl) override {
    bool extractAll = Config_getBool(EXTRACT_ALL);
    OGString result = "Список всех  ";
    if (!extractAll) {
      result += "задокументированных ";
    }

    switch (hl) {
    case ClassMemberHighlight::All:
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C)) {
        result += "полей структур и объединений";
      } else {
        result += "членов класса";
      }
      break;
    case ClassMemberHighlight::Functions:
      result += "функций";
      break;
    case ClassMemberHighlight::Variables:
      result += "переменных";
      break;
    case ClassMemberHighlight::Typedefs:
      result += "определений типов";
      break;
    case ClassMemberHighlight::Enums:
      result += "перечислителей";
      break;
    case ClassMemberHighlight::EnumValues:
      result += "значений перечислителей";
      break;
    case ClassMemberHighlight::Properties:
      result += "свойств";
      break;
    case ClassMemberHighlight::Events:
      result += "событий";
      break;
    case ClassMemberHighlight::Related:
      result += "связанных символов";
      break;
    case ClassMemberHighlight::Total: // for completeness
      break;
    }
    result += " со ссылками на ";
    if (!extractAll) {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C)) {
        result += "документацию каждого поля структуры/объединения:";
      } else {
        result += "документацию класса каждого члена:";
      }
    } else {
      if (Config_getBool(OPTIMIZE_OUTPUT_FOR_C)) {
        result += "структуры/объединения, к которым они относятся:";
      } else {
        result += "классы, к которым они относятся:";
      }
    }
    return result;
  }
  OGString trNamespaceMembersDescriptionTotal(
      NamespaceMemberHighlight::Enum hl) override {
    bool extractAll = Config_getBool(EXTRACT_ALL);
    OGString result = "Список всех ";
    if (!extractAll)
      result += "задокументированных ";
    OGString singularResult = "";
    OGString pluralResult = "";
    switch (hl) {
    case NamespaceMemberHighlight::All:
      singularResult = "члена";
      pluralResult = "членов";
      break;
    case NamespaceMemberHighlight::Functions:
      singularResult = "функции";
      pluralResult = "функций";
      break;
    case NamespaceMemberHighlight::Variables:
      singularResult = "переменной";
      pluralResult = "переменных";
      break;
    case NamespaceMemberHighlight::Typedefs:
      singularResult = "определения";
      pluralResult = "определений типов";
      break;
    case NamespaceMemberHighlight::Sequences:
      singularResult = "последовательности";
      pluralResult = "последовательностей";
      break;
    case NamespaceMemberHighlight::Dictionaries:
      singularResult = "словаря";
      pluralResult = "словарей";
      break;
    case NamespaceMemberHighlight::Enums:
      singularResult = "перечислителя";
      pluralResult = "перечислителей";
      break;
    case NamespaceMemberHighlight::EnumValues:
      singularResult = "значения";
      pluralResult = "значений перечислителей";
      break;
    case NamespaceMemberHighlight::Total: // for completeness
      break;
    }
    result += pluralResult + " со ссылками на ";
    if (extractAll)
      result +=
          "документацию пространства имён для каждого " + singularResult + ":";
    else
      result += "пространство имён, к которому они принадлежат:";
    return result;
  }
  OGString trDefinition() override { return "Определения"; }
  OGString trDeclaration() override { return "Объявления"; }

  //////////////////////////////////////////////////////////////////////////
  // new since 1.9.8
  //////////////////////////////////////////////////////////////////////////

  OGString trTopics() override { return "Разделы"; }
  OGString trTopicDocumentation() override { return "Документация разделов"; }
  OGString trTopicList() override { return "Список разделов"; }
  OGString trTopicIndex() override { return "Указатель разделов"; }
  OGString trTopicListDescription() override {
    return "Список всех разделов c краткими описаниями:";
  }
  OGString
  trModuleMembersDescriptionTotal(ModuleMemberHighlight::Enum hl) override {
    bool extractAll = Config_getBool(EXTRACT_ALL);
    OGString result = "Список всех ";
    if (!extractAll)
      result += "задокументированных ";
    OGString singularResult = "";
    OGString pluralResult = "";
    switch (hl) {
    case ModuleMemberHighlight::All:
      singularResult = "члена";
      pluralResult = "членов";
      break;
    case ModuleMemberHighlight::Functions:
      singularResult = "функции";
      pluralResult = "функций";
      break;
    case ModuleMemberHighlight::Variables:
      singularResult = "переменной";
      pluralResult = "переменных";
      break;
    case ModuleMemberHighlight::Typedefs:
      singularResult = "определения";
      pluralResult = "определений типов";
      break;
    case ModuleMemberHighlight::Enums:
      singularResult = "перечислителя";
      pluralResult = "перечислителей";
      break;
    case ModuleMemberHighlight::EnumValues:
      singularResult = "значения";
      pluralResult = "значений перечислителей";
      break;
    case ModuleMemberHighlight::Total: // for completeness
      break;
    };
    result += pluralResult + " со ссылками на ";
    if (extractAll)
      result += "на документацию модуля для каждого " + singularResult + ":";
    else
      result += "на модуль к которому они принадлежат:";
    return result;
  }
  OGString trExportedModules() override { return "Экспортируемые модули"; }

  //////////////////////////////////////////////////////////////////////////
  // new since 1.10.0
  //////////////////////////////////////////////////////////////////////////

  OGString trCopyToClipboard() override { return "Скопировать в буфер обмена"; }
  //////////////////////////////////////////////////////////////////////////
  // new since 1.11.0
  //////////////////////////////////////////////////////////////////////////
  OGString trImportant() override { return "Важно!"; }
};

#endif
